    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.security.DigestInputStream

    java.lang.Object
       |
       +----java.io.InputStream
               |
               +----java.io.FilterInputStream
                       |
                       +----java.security.DigestInputStream

public class DigestInputStream
extends FilterInputStream

A transparent stream that updates the associated message digest using the bits going through the stream.

To complete the message digest computation, call one of the `digest` methods on the associated message digest after your calls to one of this digest input stream's read methods.

It is possible to turn this stream on or off (see on). When it is on, a call to `read` results in an update on the message digest. But when it is off, the message digest is not updated. The default is for the stream to be on.

Note that digest objects can compute only one digest (see MessageDigest), so that in order to compute intermediate digests, a caller should retain a handle onto the digest object, and clone it for each digest to be computed, leaving the orginal digest untouched.

See Also:
  MessageDigest, DigestOutputStream

##

digest
  The message digest associated with this stream.

##

DigestInputStream(InputStream, MessageDigest)
  Creates a digest input stream, using the specified input stream and message digest.

##

getMessageDigest()
  Returns the message digest associated with this stream.
on(boolean)
  Turns the digest function on or off.
read()
  Reads a byte, and updates the message digest (if the digest function is on).
read(byte[], int, int)
  Reads into a byte array, and updates the message digest (if the digest function is on).
setMessageDigest(MessageDigest)
  Associates the specified message digest with this stream.
toString()
  Prints a string representation of this digest input stream and its associated message digest object.

##

digest

     protected MessageDigest digest

  The message digest associated with this stream.

##

DigestInputStream

     public DigestInputStream(InputStream stream,
                              MessageDigest digest)

  Creates a digest input stream, using the specified input stream and message digest.

  Parameters:
    stream - the input stream.
    digest - the message digest to associate with this stream.

##

getMessageDigest

     public MessageDigest getMessageDigest()

  Returns the message digest associated with this stream.

  Returns:
    the message digest associated with this stream.

setMessageDigest

     public void setMessageDigest(MessageDigest digest)

  Associates the specified message digest with this stream.

  Parameters:
    digest - the message digest to be associated with this stream.

read

     public int read() throws IOException

  Reads a byte, and updates the message digest (if the digest function is on). That is, this method reads a byte from the input stream, blocking until the byte is actually read. If the digest function is on (see on), this method will then call `update` on the message digest associated with this stream, passing it the byte read.

  Returns:
    the byte read.
  Throws: IOException
    if an I/O error occurs.
  Overrides:
    read in class FilterInputStream
  See Also:
    update

read

     public int read(byte b[],
                     int off,
                     int len) throws IOException

  Reads into a byte array, and updates the message digest (if the digest function is on). That is, this method reads up to `len` bytes from the input stream into the array `b`, starting at offset `off`. This method blocks until the data is actually read. If the digest function is on (see on), this method will then call `update` on the message digest associated with this stream, passing it the data.

  Parameters:
    b - the array into which the data is read.
    off - the starting offset into `b` of where the data should be placed.
    len - the maximum number of bytes to be read from the input stream into b, starting at offset `off`.
  Returns:
    the actual number of bytes read. This is less than `len` if the end of the stream is reached prior to reading `len` bytes. -1 is returned if no bytes were read because the end of the stream had already been reached when the call was made.
  Throws: IOException
    if an I/O error occurs.
  Overrides:
    read in class FilterInputStream
  See Also:
    update

on

     public void on(boolean on)

  Turns the digest function on or off. The default is on. When it is on, a call to read results in an update on the message digest. But when it is off, the message digest is not updated.

  Parameters:
    on - true to turn the digest function on, false to turn it off.

toString

     public String toString()

  Prints a string representation of this digest input stream and its associated message digest object.

  Overrides:
    toString in class Object

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.